local SpecSwap = {}

SpecSwap.Version = 1.0;
SpecSwap.VersionBroadcast = 1;

-- Bindings.xml Variables
BINDING_HEADER_SpecSwap_Header = "SpecSwap";
BINDING_NAME_SpecSwap_FirstSpec = "Swap to First Spec";
BINDING_NAME_SpecSwap_SecondSpec = "Swap to Second Spec";
BINDING_NAME_SpecSwap_ThirdSpec = "Swap to Third Spec";
BINDING_NAME_SpecSwap_FourthSpec = "Swap to Fourth Spec";

function SpecSwap:Log(msg)
	if (msg == nil) then
		return;
	end

	DEFAULT_CHAT_FRAME:AddMessage(string.format("|cff33ff99SS:|cffffff78 %s", msg));
end

function SpecSwap:Initialize()
	if (1 == SpecSwap.VersionBroadcast) then
		SpecSwap.VersionBroadcast = 0;
		SpecSwap:Log(string.format("SpecSwap version %s loaded.", SpecSwap.Version));
	end
end

function SpecSwap:OnEvent(event, ...)	
	if ("ADDON_LOADED" == event) then
		SpecSwap:Initialize();
	end
	
	if ("ACTIVE_TALENT_GROUP_CHANGED" == event) then
		SpecSwap_SwapEquipment(GetSpecialization());
	end
end

function SpecSwap_IsLegion()
	local version, build, _date, tocversion = GetBuildInfo();
	return (70000 <= tocversion);
end

function SpecSwap_GetSpecializationName(specIndex)
	if specIndex > GetNumSpecializations() then
		return "";
	else
		local id, name, description, icon, background, role = GetSpecializationInfo(specIndex);
		return name;
	end
end

function SpecSwap_SwapSpec(specIndex)
	SpecSwap_SwapEquipment(specIndex);
	
	if SpecSwap_IsLegion() then
		if (specIndex ~= GetSpecialization()) then
			SetSpecialization(specIndex);
		end
	else
		SetActiveSpecGroup(specIndex);
	end
end

function SpecSwap_SwapEquipment(specIndex)
	UseEquipmentSet(SpecSwap_GetSpecializationName(specIndex));
end

function SpecSwap_FirstSpec()
	SpecSwap_SwapSpec(1);
end

function SpecSwap_SecondSpec()
	SpecSwap_SwapSpec(2);
end

function SpecSwap_ThirdSpec()
	SpecSwap_SwapSpec(3);
end

function SpecSwap_FourthSpec()
	SpecSwap_SwapSpec(4);
end

SpecSwap.frame = CreateFrame("Frame");
SpecSwap.frame:SetScript("OnEvent", SpecSwap.OnEvent);
SpecSwap.frame:RegisterEvent("ADDON_LOADED");
SpecSwap.frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
-- SpecSwap.frame:RegisterEvent("RAID_INSTANCE_WELCOME");
-- SpecSwap.frame:RegisterEvent("PLAYER_ROLES_ASSIGNED");
-- SpecSwap.frame:RegisterEvent("PLAYER_TALENT_UPDATE");
